package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERBitString;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;

public class OriginatorPublicKey extends ASN1Encodable {
   private AlgorithmIdentifier algorithm;
   private DERBitString publicKey;

   public OriginatorPublicKey(AlgorithmIdentifier algorithm, byte[] publicKey) {
      OriginatorPublicKey var10000 = this;
      super();
      this.algorithm = algorithm;
      DERBitString var3;
      var3 = new DERBitString.<init>(publicKey);
      var10000.publicKey = var3;
   }

   public OriginatorPublicKey(ASN1Sequence seq) {
      this.algorithm = AlgorithmIdentifier.getInstance(seq.getObjectAt(0));
      this.publicKey = (DERBitString)seq.getObjectAt(1);
   }

   public static OriginatorPublicKey getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(ASN1Sequence.getInstance(obj, explicit));
   }

   public static OriginatorPublicKey getInstance(Object obj) {
      if (obj != null && !(obj instanceof OriginatorPublicKey)) {
         if (obj instanceof ASN1Sequence) {
            return new OriginatorPublicKey((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("Invalid OriginatorPublicKey: " + obj.getClass().getName());
         }
      } else {
         return (OriginatorPublicKey)obj;
      }
   }

   public AlgorithmIdentifier getAlgorithm() {
      return this.algorithm;
   }

   public DERBitString getPublicKey() {
      return this.publicKey;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.algorithm);
      var10000.add(this.publicKey);
      return new DERSequence(var1);
   }
}
